/**
 * Adds all built-in formatters with default names
 */
module.exports = function(fragments) {
  if (!fragments || typeof fragments.registerFormatter !== 'function') {
    throw new TypeError('formatters requires an instance of fragments to register with');
  }

  fragments.registerFormatter('addQuery', require('./add-query'));
  fragments.registerFormatter('at', require('./at'));
  fragments.registerFormatter('autolink', require('./autolink'));
  fragments.registerFormatter('bool', require('./bool'));
  fragments.registerFormatter('br', require('./br'));
  fragments.registerFormatter('dateTime', require('./date-time'));
  fragments.registerFormatter('date', require('./date'));
  fragments.registerFormatter('escape', require('./escape'));
  fragments.registerFormatter('filter', require('./filter'));
  fragments.registerFormatter('first', require('./first'));
  fragments.registerFormatter('flatten', require('./flatten'));
  fragments.registerFormatter('float', require('./float'));
  fragments.registerFormatter('format', require('./format'));
  fragments.registerFormatter('int', require('./int'));
  fragments.registerFormatter('json', require('./json'));
  fragments.registerFormatter('keys', require('./keys'));
  fragments.registerFormatter('last', require('./last'));
  fragments.registerFormatter('limit', require('./limit'));
  fragments.registerFormatter('log', require('./log'));
  fragments.registerFormatter('lower', require('./lower'));
  fragments.registerFormatter('map', require('./map'));
  fragments.registerFormatter('newline', require('./newline'));
  fragments.registerFormatter('p', require('./p'));
  fragments.registerFormatter('reduce', require('./reduce'));
  fragments.registerFormatter('reverse', require('./reverse'));
  fragments.registerFormatter('slice', require('./slice'));
  fragments.registerFormatter('sort', require('./sort'));
  fragments.registerFormatter('time', require('./time'));
  fragments.registerFormatter('upper', require('./upper'));
  fragments.registerFormatter('values', require('./values'));
};
